<?php

/**
 * Простой пример скачивания CML-данных
 */

//
$SUBTOTAL_URL = 'http://localhost:8081/';

// URL авторизации
$auth_url = $SUBTOTAL_URL . 'webapi/login';

// Обязательный параметр - id владельца бизнеса.
$owner_id = 54141;

// URL'ы для скачивания требуемых данных
$cml_import_xml_url = $SUBTOTAL_URL . 'id' . $owner_id . '/addons/cms/cml/import.xml';
$cml_offers_xml_url = $SUBTOTAL_URL . 'id' . $owner_id . '/addons/cms/cml/offers.xml';

// Авторизационные данные
$email = 'gd@subtotal.ru';
$password = '1';


// Подготовка curl-запроса
$curl_data = array(
    'login' => $email,
    'password' => $password
);

$curl = curl_init($auth_url);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

// Без печенек требуемые данные не получить. Испечём их!
$cookies_file_name = tempnam(sys_get_temp_dir(), 'cml-cookies-');
curl_setopt($curl, CURLOPT_COOKIEJAR, $cookies_file_name);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

// Авторизация
$headers = array(
   'Accept: application/json',
   'Content-Type: application/json',
);
$json_data = json_encode($curl_data);
curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
curl_setopt($curl, CURLOPT_POSTFIELDS, $json_data);
curl_setopt($curl, CURLOPT_URL, $auth_url);
curl_setopt($curl, CURLOPT_POST, true);
// $resp = curl_exec($curl);
$http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
if ($http_code != 200) {
    throw new Exception('Ошибка авторизации');
}


// Запрос import.xml
curl_setopt($curl, CURLOPT_URL, $cml_import_xml_url);
curl_setopt($curl, CURLOPT_POST, false);
$resp = curl_exec($curl);
$http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
$import_xml_filename = '/расположение/файла/import.xml';
if ($http_code == 200) {
    fopen($import_xml_filename, 'w+');
    fwrite($fp, $resp);
    fclose($fp);
} else {
    throw new Exception('Ошибка получения import.xml файла');
}


// Запрос offers.xml
curl_setopt($curl, CURLOPT_URL, $cml_offers_xml_url);
curl_setopt($curl, CURLOPT_POST, false);
$resp = curl_exec($curl);
$http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
$offers_xml_filename = '/расположение/файла/offers.xml';
if ($http_code == 200) {
    fopen($offers_xml_filename, 'w+');
    fwrite($fp, $resp);
    fclose($fp);
} else {
    throw new Exception('Ошибка получения offers.xml файла');
}


curl_close($curl);

/* Логика импорта данных в БД */
// start_import_import_xml(import_xml_filename);
// start_import_offers_xml($offers_xml_filename);

// Чистка.
unlink($import_xml_filename);
unlink($offers_xml_filename);

// Печеньки тоже можно утилизировать.
// А можно оставить до следующего использования.
unlink($cookies_file_name);